package io.vaadinpush.issuereprod

import io.quarkus.runtime.ShutdownEvent
import io.quarkus.runtime.StartupEvent
import jakarta.enterprise.context.ApplicationScoped
import jakarta.enterprise.event.Observes
import org.slf4j.Logger
import org.slf4j.LoggerFactory


@ApplicationScoped
open class AppLifecycle {

    private val logger: Logger by lazy {
        LoggerFactory.getLogger(this::class.java)
    }

    fun onStart(@Observes ev: StartupEvent?) {
        logger.info("The application has started...")
    }

    fun onStop(@Observes ev: ShutdownEvent?) {
        logger.info("The application is stopping...")
    }

}