package io.vaadinpush.issuereprod.configuration

import com.vaadin.flow.component.page.AppShellConfigurator
import com.vaadin.flow.component.page.LoadingIndicatorConfiguration
import com.vaadin.flow.component.page.Push
import com.vaadin.flow.server.AppShellSettings
import com.vaadin.flow.server.ServiceInitEvent
import com.vaadin.flow.server.VaadinServiceInitListener
import com.vaadin.flow.server.VaadinServletRequest
import com.vaadin.flow.shared.communication.PushMode
import com.vaadin.flow.shared.ui.Transport
import com.vaadin.flow.theme.Theme
import jakarta.enterprise.context.ApplicationScoped


@ApplicationScoped
@Theme("vaadinpushissuereprod", variant = "light")
@Push(PushMode.AUTOMATIC,transport = Transport.WEBSOCKET)
open class VaadinAppShell : AppShellConfigurator,VaadinServiceInitListener {


    override fun configurePage(settings: AppShellSettings?) {
        super.configurePage(settings)

    }

    override fun serviceInit(serviceInitEvent: ServiceInitEvent?) {
        serviceInitEvent?.source?.addUIInitListener { uiInitEvent ->
            val conf: LoadingIndicatorConfiguration? = uiInitEvent?.ui?.loadingIndicatorConfiguration

            // disable default theme -> loading indicator isn't shown
            conf?.isApplyDefaultTheme = false

            /*
             * Delay for showing the indicator and setting the 'first' class name.
             */
            conf?.firstDelay = 1000 // 300ms is the default

            /* Delay for setting the 'second' class name */
            conf?.secondDelay = 10_000 // 1500ms is the default

            /* Delay for setting the 'third' class name */
            conf?.thirdDelay = 100_000 // 5000ms is the default
        }
    }

    private fun getViewUrl(settings: AppShellSettings?): String? {
        return (settings?.request as? VaadinServletRequest)?.requestURI?.toString()
    }
}