package io.vaadinpush.issuereprod.pageRoute.base


import com.vaadin.flow.component.AttachEvent
import com.vaadin.flow.component.DetachEvent
import com.vaadin.flow.component.applayout.AppLayout
import io.vaadinpush.issuereprod.util.extension.cancelQuietly
import io.vaadinpush.issuereprod.util.vaadinCoroutines.vaadin
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.SupervisorJob
import kotlin.coroutines.CoroutineContext

open class BaseAppLayoutCoroutineScopedView: AppLayout(), CoroutineScope {

    private val uiScope = SupervisorJob()
    private val uiCoroutineContext = vaadin()

    override val coroutineContext: CoroutineContext
        get() = uiCoroutineContext + uiScope

    override fun onAttach(attachEvent: AttachEvent?) {
        super.onAttach(attachEvent)
    }

    override fun onDetach(detachEvent: DetachEvent?) {
        super.onDetach(detachEvent)

        uiScope.cancelQuietly("onDetach")
        coroutineContext.cancelQuietly("onDetach")
    }
}