package io.vaadinpush.issuereprod.pageRoute.base

import com.vaadin.flow.component.orderedlayout.FlexComponent
import com.vaadin.flow.router.*
import org.slf4j.Logger
import org.slf4j.LoggerFactory


// Import a style sheet into the local scope of the TextField component
//@ExperimentalStdlibApi

open class BaseView(private val fullSize: Boolean) : BaseCoroutineScopedView(), BeforeEnterObserver, BeforeLeaveObserver,
    AfterNavigationObserver {

    private val TAG = "BaseView"

    protected val logger: Logger by lazy {
        LoggerFactory.getLogger(this::class.java)
    }

    init {
        if (fullSize) {
            setSizeFull()
        }
        isPadding = false
        alignItems = FlexComponent.Alignment.CENTER
        justifyContentMode = FlexComponent.JustifyContentMode.START
    }


    override fun beforeEnter(event: BeforeEnterEvent?) {

    }

    override fun beforeLeave(event: BeforeLeaveEvent?) {

    }

    override fun afterNavigation(event: AfterNavigationEvent?) {

    }

}