package io.vaadinpush.issuereprod.pageRoute.base

import com.vaadin.flow.component.AttachEvent
import com.vaadin.flow.component.DetachEvent
import io.vaadinpush.issuereprod.util.ViewModel
import org.slf4j.Logger
import org.slf4j.LoggerFactory
import java.util.*

open class BaseViewModel(private val sessionId:String,private val locale:Locale):ViewModel() {

    protected val logger: Logger by lazy {
        LoggerFactory.getLogger(this::class.java)
    }

    open fun onAttach(attachEvent: AttachEvent?) {

    }

    open fun onDetach(detachEvent: DetachEvent?) {
        destroyScope()
    }




}