package io.vaadinpush.issuereprod.pageRoute.home

import com.vaadin.flow.component.AttachEvent
import com.vaadin.flow.component.DetachEvent
import com.vaadin.flow.server.WebBrowser
import io.vaadinpush.issuereprod.pageRoute.base.BaseViewModel
import kotlinx.coroutines.delay
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.StateFlow
import kotlinx.coroutines.launch
import java.util.*

open class HomePageViewModel(
    private val sessionId:String,
    private val locale: Locale,
    private val webBrowser: WebBrowser
    ) : BaseViewModel(sessionId, locale) {

    private val TAG = "HomeViewModel"

    private val counterValueList:MutableList<Int> = Collections.synchronizedList(mutableListOf())
    private val counterValue = MutableStateFlow<List<Int>>(listOf())

    override fun onAttach(attachEvent: AttachEvent?) {
        super.onAttach(attachEvent)

        viewModelScope.launch {
            delay(1_000)
            repeat(50){
                logger.error("counterValueList / repeat -> ${it}")
                counterValueList.add(it)
                setCounterValueList(counterValueList)
                delay(1_000)
            }

        }
    }

    override fun onDetach(detachEvent: DetachEvent?) {
        super.onDetach(detachEvent)
    }

    private fun setCounterValueList(value: List<Int>) {
        this.counterValue.tryEmit(value)
    }

    fun getCounterValueList(): StateFlow<List<Int>> {
        return counterValue
    }



}