package io.vaadinpush.issuereprod.pageRoute.main

import com.vaadin.flow.component.AttachEvent
import com.vaadin.flow.component.DetachEvent
import com.vaadin.flow.component.orderedlayout.FlexComponent
import com.vaadin.flow.component.orderedlayout.HorizontalLayout
import com.vaadin.flow.component.tabs.Tab
import com.vaadin.flow.router.*
import com.vaadin.quarkus.annotation.UIScoped
import io.vaadinpush.issuereprod.pageRoute.base.BaseAppLayoutView

@ExperimentalStdlibApi
@UIScoped // https://vaadin.com/docs/latest/flow/integrations/spring/scopes
open class MainPage() : BaseAppLayoutView(), BeforeEnterObserver, BeforeLeaveObserver, AfterNavigationObserver {




    override fun onAttach(attachEvent: AttachEvent?) {
        super.onAttach(attachEvent)

        primarySection = Section.NAVBAR

        style.setBackground("#FFFFFF")


        val buttonLayout = HorizontalLayout()
        buttonLayout.isSpacing = true
        buttonLayout.setWidthFull()
        buttonLayout.alignItems = FlexComponent.Alignment.CENTER
        buttonLayout.justifyContentMode = FlexComponent.JustifyContentMode.END

        val toolbarLayoutWrapper = HorizontalLayout()
        toolbarLayoutWrapper.setWidthFull()
        toolbarLayoutWrapper.height = "60px"
        toolbarLayoutWrapper.style.setBackground("#FFFFFF")
//        toolbarLayoutWrapper.style.setBackground(ColorProvider.Hex.minifyYellow)

        toolbarLayoutWrapper.alignItems = FlexComponent.Alignment.CENTER
        toolbarLayoutWrapper.justifyContentMode = FlexComponent.JustifyContentMode.CENTER

        val toolbarLayout = HorizontalLayout()
        toolbarLayout.isSpacing = true
        toolbarLayout.isMargin = false
        toolbarLayout.isPadding = true
        toolbarLayout.style.set("border-inline-end","none")
        toolbarLayout.style.setBackground("#000000")
//        toolbarLayout.style.setPaddingLeft(DefaultUIParameters.ROOT_LAYOUT_PADDING_LEFT_RIGHT)
//        toolbarLayout.style.setPaddingRight(DefaultUIParameters.ROOT_LAYOUT_PADDING_LEFT_RIGHT)
        toolbarLayout.height = "60px"
        toolbarLayout.setWidthFull()
        toolbarLayout.defaultVerticalComponentAlignment = FlexComponent.Alignment.CENTER

        toolbarLayout.alignItems = FlexComponent.Alignment.CENTER
        toolbarLayout.expand(buttonLayout)

        toolbarLayout.add(buttonLayout)

        toolbarLayoutWrapper.add(toolbarLayout)

        addToNavbar(false, toolbarLayoutWrapper)

    }

    override fun onDetach(detachEvent: DetachEvent?) {
//        viewModel.onCleared()
        super.onDetach(detachEvent)
    }

    override fun afterNavigation(event: AfterNavigationEvent?) {


    }

    override fun beforeEnter(event: BeforeEnterEvent?) {

    }

    override fun beforeLeave(event: BeforeLeaveEvent?) {

    }

    private fun getMenuBarButton(text:String): Tab {

        val tab = Tab(text)
        tab.style.set("font-size","18px")
        return tab
    }
}