package io.vaadinpush.issuereprod.util


import io.vaadinpush.issuereprod.util.extension.cancelQuietly
import io.vaadinpush.issuereprod.util.vaadinCoroutines.vaadin
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.SupervisorJob
import kotlin.coroutines.CoroutineContext

abstract class ViewModel:CoroutineScope {

    private val uiScope = SupervisorJob() + Dispatchers.Default
    private val uiCoroutineContext = vaadin()

    override val coroutineContext: CoroutineContext
        get() = uiCoroutineContext + uiScope

    val viewModelScope: CoroutineScope by lazy {
        CoroutineScope(coroutineContext)
    }

    fun destroyScope() {
        uiScope.cancelQuietly("ViewModel.clear")
        viewModelScope.cancelQuietly("ViewModel.clear")
    }
}