package io.vaadinpush.issuereprod.util.coroutines

import java.util.concurrent.ThreadFactory
import java.util.concurrent.atomic.AtomicInteger


class CoroutineThreadFactory @JvmOverloads constructor(private val priority: Int, private val daemon: Boolean = true) : ThreadFactory {
    private val namePrefix: String = "jobpool-" + poolNumber.getAndIncrement() + "-thread-"
    private val threadNumber = AtomicInteger(1)

    override fun newThread(r: Runnable): Thread {
        val t = Thread(r, namePrefix + threadNumber.getAndIncrement())
        t.setDaemon(daemon)
        t.setPriority(priority)
        return t
    }

    companion object {
        private val poolNumber = AtomicInteger(1)
    }
}