package io.vaadinpush.issuereprod.util.extension

import java.util.*
import java.util.concurrent.ArrayBlockingQueue

fun <T> ArrayBlockingQueue<T>.drainAllFromQueue():List<T>{
    val list: MutableList<T> = Collections.synchronizedList(mutableListOf())
    try {
        while (iterator().hasNext()) {
            val item:T = poll()
            if(item != null){
                list.add(item)
            }
        }
    }finally {
        clear()
    }
    return list
}