package io.vaadinpush.issuereprod.util.extension

import kotlinx.coroutines.CoroutineDispatcher
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.asCoroutineDispatcher
import java.util.concurrent.Executors

val Dispatchers.MI_VIEWMODEL: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(4)
}

val Dispatchers.MI_FRONTEND: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(2)
}

val Dispatchers.MI_SINGLE_THREAD: CoroutineDispatcher by lazy {
    Executors.newSingleThreadExecutor().asCoroutineDispatcher()
}

val Dispatchers.MI_REST_IO: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(1_000)
}

val Dispatchers.MI_IO_LOGGING: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(4)
}

val Dispatchers.MI_IO: CoroutineDispatcher by lazy {
    Executors.newWorkStealingPool(5).asCoroutineDispatcher()
}

val Dispatchers.MI_IO_DOWNLOAD: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(500)
}

val Dispatchers.MI_IO_LIMITLESS: CoroutineDispatcher by lazy {
    Executors.newCachedThreadPool().asCoroutineDispatcher()
}

val Dispatchers.MI_CPU_INTENSIVE: CoroutineDispatcher by lazy {
    Dispatchers.getDispatcherWithLimitedThreads(Runtime.getRuntime().availableProcessors().coerceAtLeast(8))
}

val Dispatchers.MI_CPU_INTENSIVE_LIMITLESS: CoroutineDispatcher by lazy {
    Executors.newCachedThreadPool().asCoroutineDispatcher()
}

val Dispatchers.MI_IO_CPU_INTENSIVE_BALANCED: CoroutineDispatcher by lazy {
    Executors.newVirtualThreadPerTaskExecutor().asCoroutineDispatcher().limitedParallelism(10)
}

fun Dispatchers.getDispatcherWithLimitedThreads(threadsMax:Int):CoroutineDispatcher{
    return Executors.newFixedThreadPool(threadsMax).asCoroutineDispatcher()
}
