package io.vaadinpush.issuereprod.util.extension


import java.io.File
import java.io.FileInputStream
import java.io.InputStream
import java.security.MessageDigest


private fun createSha1(file: File): ByteArray? {
    val digest: MessageDigest = MessageDigest.getInstance("SHA-1")
    val fis: InputStream = FileInputStream(file)
    var n = 0
    val buffer = ByteArray(1024)
    while (n != -1) {
        n = fis.read(buffer)
        if (n > 0) {
            digest.update(buffer, 0, n)
        }
    }
    return digest.digest()
}

fun File.isProbablyImage(): Boolean {
    return try {
        this.extension.equals("png", true)
                || this.extension.equals("jpg", true)
                || this.extension.equals("jpeg", true)
                || this.extension.equals("bmp", true)
                || this.extension.equals("webp", true)
    } catch (e: Exception) {
        false
    }
}

fun File.isProbablyVideo(): Boolean {
    return try {
        this.extension.equals("mov", true)
                || this.extension.equals("avi", true)
                || this.extension.equals("wmv", true)
                || this.extension.equals("mkv", true)
                || this.extension.equals("webm", true)
                || this.extension.equals("flv", true)
                || this.extension.equals("webm", true)
                || this.extension.equals("mp4", true)
                || this.extension.equals("webm", true)
    } catch (e: Exception) {
        false
    }
}