package io.vaadinpush.issuereprod.util.extension

import java.math.RoundingMode
import java.text.DecimalFormat
import java.text.DecimalFormatSymbols
import java.util.Locale

fun Double.roundToNDecimalPlaces(decimalPlaces:Int):Double{
        val pattern = "#".repeat(if(decimalPlaces <= 0) 1 else decimalPlaces)
        val df = DecimalFormat("#.${pattern}",DecimalFormatSymbols.getInstance(Locale.US))
        df.roundingMode = RoundingMode.CEILING
        return df.format(this).toDouble()
}

fun Float.roundToNDecimalPlaces(decimalPlaces:Int):Float{
        val pattern = "#".repeat(if(decimalPlaces <= 0) 1 else decimalPlaces)
        val df = DecimalFormat("#.${pattern}",DecimalFormatSymbols.getInstance(Locale.US))
        df.roundingMode = RoundingMode.CEILING
        return df.format(this).toFloat()
}

fun Int.toBoolean(): Boolean {
        return (this != 0)
}

fun Int.toBooleanOrNull(): Boolean? {
        return try {
                (this != 0)
        } catch (e: Exception) {
                null
        }
}