package io.vaadinpush.issuereprod.util.extension


import org.apache.commons.lang3.StringUtils
import java.util.*

fun String?.isNull():Boolean{
    return this == null || this.isBlank() || this.isEmpty()
}

fun String?.isNotNull():Boolean{
    return !isNull()
}

fun String.capitalized(locale: Locale = Locale.getDefault()): String {
    return this.replaceFirstChar {
        if (it.isLowerCase())
            it.titlecase(Locale.getDefault())
        else it.toString()
    }
}

fun String?.isAlphanumericWithAllowedCharacters(allowedCharactersArray: Array<String>
): Boolean {
    return if (!StringUtils.isAlphanumeric(this)) {
        this?.filter { !it.isLetterOrDigit() }?.forEach { character ->
            if(!allowedCharactersArray.contains(character.toString())){
                return false
            }
        }
        true
    } else {
        true
    }
}

fun String?.isNumber():Boolean{
    return isNotNull() && (this?.toIntOrNull() != null || this?.toLongOrNull() != null || this?.toDoubleOrNull() != null || this?.toFloatOrNull() != null || this?.toBigDecimalOrNull() != null)
}

fun String?.isText():Boolean{
    return !isNumber()
}

fun String?.hasOnlyLetters():Boolean {
    return this?.chars()?.allMatch(Character::isLetter) == true
}

fun String?.hasOnlyNumbers():Boolean {
    return this?.chars()?.allMatch(Character::isDigit) == true
}