package io.vaadinpush.issuereprod.util.extension

import com.vaadin.flow.component.button.Button
import com.vaadin.flow.component.select.Select
import com.vaadin.flow.dom.Element

private var required: Boolean = false
private var selected: Boolean = false
fun <T> Select<T>.setRequired(value: Boolean) {
    required = value
}

fun <T> Select<T>.isRequired(): Boolean {
    return required
}

fun Button.setSelected(value: Boolean, clickInClient: Boolean = false) {
    selected = value
    if (value && clickInClient) {
        clickInClient()
    }
}

fun Button.isSelected(): Boolean {
    return selected
}

fun Element.setInnerHtml(content: String) {
    this.executeJs("this.innerHTML = $0", content)
}

