package io.vaadinpush.issuereprod.util.extension

import com.vaadin.flow.component.upload.Upload
import elemental.json.Json
import java.io.File

// https://vaadin.com/forum/thread/17241527/how-to-clear-the-file-list-on-an-upload-component
fun Upload.setUploadedFilesList(newList:List<File>){
    val jsonArray = Json.createArray()
    newList.forEachIndexed { index, file ->
        val jsonObject = Json.createObject()
        jsonObject.put("name", file.name)
        jsonObject.put("progress", "100")
        jsonObject.put("complete", true)
        jsonArray.set(index,jsonObject)
    }
    element?.setPropertyJson("files", jsonArray)
}